<imeoff-textarea>
<div id="{divid}">
<textarea id="{id}" name="{id}" style="{style}" class="{css}" onkeyup={changefunc} onfocus={focusFunc} onblur={blurFunc}>{value}</textarea>
<br />
<wms-label id="{lid}" value="{this.txtValue}"></wms-label>
<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
</div>
<script>
	this.id = opts.tagid;
	this.divid = opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled;' + (opts.style ? opts.style : '');
	this.value = opts.value;
	this.msgstyle = opts.msgstyle;
	
	this.regptn = /[^A-Za-z0-9\n]+/;
	this.lid = this.id + 'Label';
	
	this.nowlength = $('#' + this.id).val() ? $('#' + this.id).val().length : '0';
	this.maxlength = opts.maxlength;
	this.txtValue = this.maxlength ? '窶ｻ縲�' + this.nowlength + '/' + this.maxlength.replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,') + ' ' + common.textareaMaxLength : '';
	
	this.on('updated', function() {
		this.changefunc();
	});
	
	changefunc() {
		this.nowlength = $('#' + this.id).val().length;
		this.txtValue = this.maxlength ? '窶ｻ縲�' + this.nowlength + '/' + this.maxlength.replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,') + ' ' + common.textareaMaxLength : '';
		$('#' + this.lid).html(this.txtValue);
		
		if($('#' + this.id).val().length > this.maxlength) {
			console.log('err001:' + $(this.messageid));
		}
		if($('#' + this.id).val().match(this.regptn)) {
			console.log('err002:' + $(this.messageid));
		}
	}

	// フォーカスin時の値を保持
	this._tmpVal = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpVal = $('#' + this.id).val();
	}

	/**
	 * フォーカスout時の処理
	 */
	blurFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.id).val();
		if (this._tmpVal != aftVal) {
			updFlg = true;
			$('#' + this.id).attr('data-updflg', '1');
		}
	}

	/**
	 * マウント時の処理
	 */
	this.on('mount', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id).attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
	
</script>
</imeoff-textarea>
